<template>
  <el-dialog title="Upload reports" :visible.sync="dialogVisible" @close="cancelForm()">
    <el-upload class="file-dropzone" ref="upload" action="/calls/upload_report" drag :auto-upload="false" multiple
               :show-file-list="false" :on-change="addFile" :on-success="submitForm">
      <i class="el-icon-upload"></i>
      <div class="el-upload__text" style="width: 100%">Drop files here or <em>click to upload</em></div>
      <!-- <div class="el-upload__tip" slot="tip">Only audio files</div> -->
    </el-upload>

    <el-card v-for="report in reports" :key="report.key" style="margin: 10px 0">
      <div slot="header">
        <span>{{report.file.name}}</span>
        <el-button-group style="float: right; padding: 0 3px">
          <el-button plain size="mini" @click="removeFile(report.key)">remove</el-button>
        </el-button-group>
      </div>
    </el-card>
    
    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button type="primary" @click="uploadFiles()">Upload</el-button>
    </span>
  </el-dialog>  
</template>

<script>
import gql from 'graphql-tag'
import UsersQuery from '../../graphql/queries/users'

export default {
  apollo: {
    agents: {
      query: UsersQuery,
      update({ users }) { return  users },
      variables: { role: 'agent' }
    }
  },

  data() {
    return { dialogVisible: true, reports: [], agents: [], errors: [] }
  },

  methods: {
    addFile(file, fileList) {
      if (!file.raw.type.match(/^(text\/csv|application\/vnd\.openxmlformats\-officedocument\.spreadsheetml\.sheet)$/)){
        this.$message.error('The files must be in csv or xlsx format!')
        return
      }

      for(var i in this.$data.reports) {
        if(this.$data.reports[i].file.name == file.name && this.$data.reports[i].file.size == file.size) {
          fileList.pop()
          // this.$message.error('You can\'t upload the same file twice!')
          return
        }
      }

      let key = 0
      if(this.$data.reports.length > 0)
        key = this.$data.reports[this.$data.reports.length - 1].key + 1

      this.$data.reports.push({ key: key, file: file, id: null })

      return file
    },
    removeFile(key) {
      this.$data.reports.forEach((report, index, array) => {
        if(report.key == key){
          this.$data.reports.splice(index, 1)
          this.$refs.upload.$data.uploadFiles.splice(index, 1)
        }
      })
    },
    uploadFiles() {
      this.$refs.upload.submit()
    },
    submitForm(response, file, fileList) {
      if(response.success) {
        this.$data.reports.forEach((report, index, array) => {
          if(report.file.name == file.name && report.file.size == file.size)
            this.$data.reports.splice(index, 1)
        })
      }
      else
        this.$message.error('Failed to upload report')
      // this.$message.success('Files uploaded successfully')
      // this.$data.dialogVisible = false
      // this.$router.push('/calls')
    },
    cancelForm() {
      this.$parent.$apollo.queries.calls.refetch()
      this.$data.dialogVisible = false
      this.$router.push('/calls')
    }
  }
}
</script>
